/*******************************************************************************
* FILE: pgm_io.c
* This code was written by Mike Heath. heath@csee.usf.edu (in 1995).
*******************************************************************************/

#include <stdio.h>
#include <string.h>


unsigned char* read_pgm( char* filename, int* width, int* height )
{
	FILE	*ifp ;
	char	stringbuf[255];
	int		max;
	unsigned char* data;

	ifp = fopen(filename, "rb") ;
	if (!ifp) return NULL ;

	fscanf(ifp, "%s\n", stringbuf) ;
	if (strcmp(stringbuf, "P5") != 0)
	{
		return NULL ;
	}

	do {
		fgets(stringbuf, 255, ifp);
	} while (stringbuf[0] == '#'); /* skip the comment line */
	sscanf(stringbuf, "%d %d", width, height); /* width and height */

	do {
		fgets(stringbuf, 255, ifp);
	} while (stringbuf[0] == '#'); /* skip the comment line */
	sscanf(stringbuf, "%d", &max); /* maximum gray value */

    data = (unsigned char*)malloc ( *width * *height );
    fread( data, *width * *height, 1, ifp );

    fclose( ifp );
     
    return data;
}

unsigned char* read_ppm( char* filename, int* width, int* height )
{
	FILE	*ifp ;
	char	stringbuf[255];
	int		max;
	unsigned char* data;

	ifp = fopen(filename, "rb") ;
	if (!ifp) return NULL ;

	fscanf(ifp, "%s\n", stringbuf) ;
	if (strcmp(stringbuf, "P6") != 0)
	{
		return NULL ;
	}

	do {
		fgets(stringbuf, 255, ifp);
	} while (stringbuf[0] == '#'); /* skip the comment line */
	sscanf(stringbuf, "%d %d", width, height); /* width and height */

	do {
		fgets(stringbuf, 255, ifp);
	} while (stringbuf[0] == '#'); /* skip the comment line */
	sscanf(stringbuf, "%d", &max); /* maximum gray value */

    data = (unsigned char*)malloc ( *width * *height * 3);
    fread( data, *width * *height * 3, 1, ifp );

    fclose( ifp );
     
    return data;
}

int write_ppm( char *fn, int width, int height, unsigned char* data )
{
	FILE		*f ;
	f = fopen(fn, "wb") ;
	if (!f) return 1;

	fprintf( f, "P6\n%d %d\n%d\n", width, height, 255 );
	fwrite( data, width*height*3, 1, f );
	fclose( f );
	return 0;
}

void write_pgm( char *fn, int width, int height, unsigned char* data )
{
	FILE		*f ;
	f = fopen(fn, "wb") ;
	if (!f) return 1;

	fprintf( f, "P5\n%d %d\n%d\n", width, height, 255 );
	fwrite( data, width*height, 1, f );
	fclose( f );
	return 0;
}

